import * as i0 from "@angular/core";
export interface IBPS {
    bp: string;
    value: string;
    bef: string;
}
export interface IConsoleParser {
    type?: 'log' | 'info' | 'trace' | 'error';
    thing: any;
    style?: string;
    line?: string | null;
    stoper?: boolean;
}
export interface IPseudo {
    mask: string;
    real: string;
}
export declare class NgxBootstrapExpandedFeaturesService {
    colors: {
        [key: string]: string;
    };
    abreviationsClasses: {
        [key: string]: string;
    };
    abreviationsValues: {
        [key: string]: string;
    };
    combos: {
        [key: string]: string[];
    };
    combosCreated: {
        [key: string]: string;
    };
    cssNamesParsed: any;
    alreadyCreatedClasses: string[];
    sheet: any;
    isDebug: boolean;
    bps: IBPS[];
    separator: string;
    styleConsole: string;
    pseudoClasses: string[];
    pseudoElements: string[];
    pseudos: IPseudo[];
    importantActive: boolean;
    lastCSSCreate: number;
    lastTimeAsked2Create: number;
    timesCSSCreated: number;
    timeBetweenReCreate: number;
    useTimer: boolean;
    constructor();
    private checkSheet;
    cssCreate(updateBefs?: string[] | null, primordial?: boolean): void;
    private DoUseTimer;
    private ta;
    private tas;
    doCssCreate(updateBefs?: string[] | null): Promise<void>;
    createCSSRules(rule: string): void;
    colorToRGB(color: string): number[];
    RGBToRGBA(rgb: number[], alpha: number): string;
    parseRGB(rgba: string): number[];
    HexToRGB(Hex: string): string;
    HSLToRGB(HSL: string): string;
    HueToRGB(p: number, q: number, t: number): number;
    HWBToRGB(HWB: string): string;
    shadeTintColor(rgb: number[], percent: number): number[];
    private removePseudos;
    cssValidToCamel(st: string): string;
    camelToCSSValid(st: string): string;
    pushCssNamesParsed(cssNamesParsed: any): void;
    pushBPS(bps: IBPS[]): void;
    pushColors(newColors: any): void;
    pushAbreviationsValues(abreviationsValues: any): void;
    pushAbreviationsClasses(abreviationsClasses: any): void;
    pushCombos(combos: any): void;
    getColors(): any;
    getBPS(): any;
    getAbreviationsClasses(): any;
    getAbreviationsValues(): any;
    getCombos(): any;
    getCssNamesParsed(): any;
    getColorsNames(): string[];
    getColorValue(color: string): any;
    getAlreadyCreatedClasses(): string[];
    getSheet(): any;
    updateColor(color: string, value: string): void;
    updateAbreviationsClass(abreviationsClass: string, value: string): void;
    updateAbreviationsValue(abreviationsValue: string, value: string): void;
    updateCombo(combo: string, values: string[]): void;
    updateCssNamesParsed(cssNameParsed: string, value: string): void;
    updateClasses(classesToUpdate: string[]): void;
    deleteColor(color: string): void;
    clearAllColors(): void;
    changeImportantActive(): void;
    changeDebugOption(): void;
    changeUseTimerOption(): void;
    setTimeBetweenReCreate(time: number): void;
    unbefysize(value: string): string;
    befysize(value: string): string;
    private getStackTrace;
    consoleLog(type: "log" | "info" | "trace" | "error" | undefined, thing: any, style?: string, line?: string | null, stoper?: boolean): void;
    consoleParser(config: IConsoleParser): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgxBootstrapExpandedFeaturesService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<NgxBootstrapExpandedFeaturesService>;
}
